%{?scl:%scl_package tika}
%{!?scl:%global pkg_name %{name}}

%global baserelease 2

# Conditionals to help breaking tika <-> vorbis-java-tika dependency cycle
%bcond_without vorbis_tika
# Disable only for now
%bcond_with tika_parsers
%bcond_without tika_app

Name:          %{?scl_prefix}tika
Version:       1.17
Release:       1.%{baserelease}%{?dist}
Summary:       A content analysis toolkit
License:       ASL 2.0
Url:           http://tika.apache.org/
# sh tika-repack.sh <VERSION>
Source0:       %{pkg_name}-%{version}-clean.tar.xz
Source1:       tika-repack.sh

# The upstream PDFBox project retired the JempBox sub-project, so patch out it's use
# Upstream Tika should migrate to the PDFBox's XMPBox lib instead
Patch0:        tika-no-jempbox.patch

BuildRequires:  %{?scl_prefix_maven}maven-local
BuildRequires:  %{?scl_prefix_maven}mvn(biz.aQute:bndlib)
BuildRequires:  %{?scl_prefix}mvn(com.fasterxml.jackson.core:jackson-core)
BuildRequires:  %{?scl_prefix}mvn(com.fasterxml.jackson.jaxrs:jackson-jaxrs-json-provider)
BuildRequires:  %{?scl_prefix_maven}mvn(com.google.code.gson:gson)
BuildRequires:  %{?scl_prefix}mvn(com.googlecode.json-simple:json-simple)
BuildRequires:  %{?scl_prefix_maven}mvn(commons-cli:commons-cli)
BuildRequires:  %{?scl_prefix_maven}mvn(commons-codec:commons-codec)
BuildRequires:  %{?scl_prefix_maven}mvn(commons-io:commons-io)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache:apache:pom:)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.commons:commons-compress)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.commons:commons-exec)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.commons:commons-lang3)
BuildRequires:  %{?scl_prefix}mvn(org.apache.commons:commons-math3)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.httpcomponents:httpclient)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.httpcomponents:httpmime)
BuildRequires:  %{?scl_prefix}mvn(org.apache.lucene:lucene-analyzers-common)
BuildRequires:  %{?scl_prefix}mvn(org.apache.lucene:lucene-core)
BuildRequires:  %{?scl_prefix}mvn(org.apache.lucene:lucene-memory)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.maven.plugins:maven-failsafe-plugin)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.maven.plugins:maven-remote-resources-plugin)
BuildRequires:  %{?scl_prefix}mvn(org.bouncycastle:bcmail-jdk15on)
BuildRequires:  %{?scl_prefix}mvn(org.bouncycastle:bcprov-jdk15on)
%if %{without vorbis_tika}
BuildRequires:  mvn(org.gagravarr:vorbis-java-core)
BuildRequires:  mvn(org.gagravarr:vorbis-java-tika)
%endif
BuildRequires:  %{?scl_prefix_maven}mvn(org.osgi:org.osgi.compendium)
BuildRequires:  %{?scl_prefix_maven}mvn(org.osgi:org.osgi.core)
BuildRequires:  %{?scl_prefix_maven}mvn(org.ow2.asm:asm)
BuildRequires:  %{?scl_prefix_maven}mvn(org.slf4j:jcl-over-slf4j)
BuildRequires:  %{?scl_prefix_maven}mvn(org.slf4j:jul-to-slf4j)
BuildRequires:  %{?scl_prefix_maven}mvn(org.slf4j:slf4j-api)
BuildRequires:  %{?scl_prefix_maven}mvn(org.slf4j:slf4j-log4j12)
BuildRequires:  %{?scl_prefix_maven}mvn(org.tukaani:xz)

BuildArch: noarch

%description
The Apache Tika toolkit detects and extracts meta-data and
structured text content from various documents using existing
parser libraries.

%if %{without tika_parsers}
%if %{without tika_app}

%package app
Summary: Apache Tika Application

%description app
Apache Tika standalone application.
%endif

%package batch
Summary: Apache Tika Batch

%description batch
Apache Tika Batch offers robust batch processing code
filesystem input -> filesystem output on a single machine.

%package java7
Summary: Apache Tika Java-7 Components

%description java7
Java-7 reliant components, including FileTypeDetector
implementations.

%package parsers
Summary: Apache Tika Parsers

%description parsers
Apache Tika Parsers implementation that matches the
type of the document, once it is known, using
Mime Type detection.
%endif

%package parent
Summary: Apache Tika parent POM

%description parent
Apache Tika parent POM.

%package pom
Summary: Apache Tika Aggregator POM

%description pom
Apache Tika Aggregator POM.

%package serialization
Summary: Apache Tika serialization

%description serialization
Use GSON library support to serialize/deserialize
JSON Metadata objects.

%package javadoc
Summary: Javadoc for %{pkg_name}

%description javadoc
This package contains API documentation for %{pkg_name}.

%prep
%{?scl:scl enable %{scl_maven} %{scl} - << "EOFSCL"}
set -e -x
%setup -n %{pkg_name}-%{version} -q

%pom_disable_module %{pkg_name}-bundle
%pom_disable_module %{pkg_name}-example
%pom_disable_module %{pkg_name}-xmp
%pom_disable_module %{pkg_name}-langdetect
%pom_disable_module %{pkg_name}-translate
%pom_disable_module %{pkg_name}-eval

# Unavailable deps for these modules
%pom_disable_module %{pkg_name}-dl
%pom_disable_module %{pkg_name}-nlp
%pom_disable_module %{pkg_name}-server

# Unavailable plugins
%pom_remove_plugin org.codehaus.mojo:clirr-maven-plugin %{pkg_name}-core
%pom_remove_plugin org.codehaus.gmaven:groovy-maven-plugin %{pkg_name}-parsers

# Unnecessary plugins for RPM build
%pom_remove_plugin -r :apache-rat-plugin
%pom_remove_plugin :forbiddenapis %{pkg_name}-parent
%pom_remove_plugin :maven-release-plugin %{pkg_name}-parent
%pom_remove_plugin :maven-shade-plugin tika-{server,eval,app,parent}
%pom_remove_plugin :maven-scr-plugin tika-{xmp,java7}

# Disable vorbis-java-tika support, cause circular dependency
%if %{with vorbis_tika}
%pom_remove_dep org.gagravarr: %{pkg_name}-parsers
%endif

%if %{with tika_parsers}
%pom_disable_module %{pkg_name}-parsers
%pom_disable_module %{pkg_name}-xmp
%else
%if %{with tika_app}
%pom_disable_module %{pkg_name}-app
%endif
%endif

# tika-translate
# https://gil.fedorapeople.org/microsoft-translator-java-api-0.6.2-1.fc19.src.rpm
%pom_remove_dep :microsoft-translator-java-api %{pkg_name}-translate
rm %{pkg_name}-translate/src/main/java/org/apache/tika/language/translate/MicrosoftTranslator.java \
 %{pkg_name}-translate/src/test/java/org/apache/tika/language/translate/MicrosoftTranslatorTest.java
sed -i '/MicrosoftTranslator/d' %{pkg_name}-translate/src/main/resources/META-INF/services/org.apache.tika.language.translate.Translator
rm %{pkg_name}-translate/src/main/resources/org/apache/tika/language/translate/translator.microsoft.properties
%pom_change_dep :junit ::4.11:test %{pkg_name}-translate

# Unavailable build dep com.googlecode.mp4parser:isoparser
# MP4 is non-free remove support for it
%pom_remove_dep com.googlecode.mp4parser:isoparser %{pkg_name}-parsers
rm -r tika-parsers/src/main/java/org/apache/tika/parser/mp4/ \
      tika-parsers/src/main/java/org/apache/tika/parser/pot/
# NON FREE under UnRar License
%pom_remove_dep com.github.junrar:junrar %{pkg_name}-parsers
rm %{pkg_name}-parsers/src/main/java/org/apache/tika/parser/pkg/RarParser.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/RarParserTest.java
# sis & geoapi use NON FREE deps: javax.measure:jsr-275
%pom_remove_dep org.apache.sis.core:sis-utility %{pkg_name}-parsers
%pom_remove_dep org.apache.sis.storage:sis-netcdf %{pkg_name}-parsers
%pom_remove_dep org.apache.sis.core:sis-metadata %{pkg_name}-parsers
#  https://github.com/opengeospatial/geoapi/issues/8
%pom_remove_dep org.opengis:geoapi %{pkg_name}-parsers
rm -r %{pkg_name}-parsers/src/main/java/org/apache/tika/parser/geoinfo \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/geoinfo
%pom_remove_dep org.apache.ctakes:ctakes-core %{pkg_name}-parsers
rm -r %{pkg_name}-parsers/src/main/java/org/apache/tika/parser/ctakes
# Remove NON FREE json.org support
%pom_remove_dep com.tdunning:json tika-parsers
rm -r tika-parsers/src/main/java/org/apache/tika/parser/{journal,recognition,captioning} \
      tika-parsers/src/main/java/org/apache/tika/parser/ner/{corenlp,nltk,grobid}
# Sentiment analysis not available in Fedora
%pom_remove_dep :sentiment-analysis-parser tika-parsers
rm -r tika-parsers/src/main/java/org/apache/tika/parser/sentiment
# Upstream pdfbox EOL'd the jempbox subproject
%pom_remove_dep org.apache.pdfbox:jempbox tika-parsers
rm -r tika-parsers/src/main/java/org/apache/tika/parser/image/xmp \
      tika-parsers/src/main/java/org/apache/tika/parser/pdf/PDFParser.java
%patch0
# No longer need CXF
%pom_remove_dep :cxf-rt-rs-client tika-parsers
# Various dep fixes for parsers
%pom_change_dep org.tallison:jmatio net.sourceforge.jmatio:jmatio tika-parsers
sed -i -e '/setAllowObjectDeserialization/d' tika-parsers/src/main/java/org/apache/tika/parser/mat/MatParser.java
%pom_change_dep :metadata-extractor ::2 tika-parsers

%pom_remove_dep com.healthmarketscience.jackcess:jackcess %{pkg_name}-parsers
%pom_remove_dep com.healthmarketscience.jackcess:jackcess-encrypt %{pkg_name}-parsers
%pom_remove_dep org.apache.felix:org.apache.felix.scr.annotations %{pkg_name}-parsers
%pom_remove_dep net.sourceforge.jmatio:jmatio %{pkg_name}-parsers
%pom_remove_dep org.apache.james:apache-mime4j-core %{pkg_name}-parsers
%pom_remove_dep org.apache.james:apache-mime4j-dom %{pkg_name}-parsers
%pom_remove_dep org.apache.pdfbox:pdfbox %{pkg_name}-parsers
%pom_remove_dep org.apache.pdfbox:pdfbox-tools %{pkg_name}-parsers
%pom_remove_dep org.apache.poi: %{pkg_name}-parsers
%pom_remove_dep org.ccil.cowan.tagsoup:tagsoup %{pkg_name}-parsers
%pom_remove_dep com.drewnoakes:metadata-extractor %{pkg_name}-parsers
%pom_remove_dep de.l3s.boilerpipe:boilerpipe %{pkg_name}-parsers
%pom_remove_dep com.rometools:rome %{pkg_name}-parsers
%pom_remove_dep com.googlecode.juniversalchardet:juniversalchardet %{pkg_name}-parsers
%pom_remove_dep org.codelibs:jhighlight %{pkg_name}-parsers
%pom_remove_dep com.pff:java-libpst %{pkg_name}-parsers
%pom_remove_dep org.xerial:sqlite-jdbc %{pkg_name}-parsers
%pom_remove_dep org.apache.opennlp:opennlp-tools %{pkg_name}-parsers
%pom_remove_dep edu.ucar: %{pkg_name}-parsers
%pom_remove_dep org.apache.commons:commons-csv %{pkg_name}-parsers
rm -rf tika-parsers/src/main/java/org/apache/tika/parser/{asm,chm,code,dbf,dif,dwg,executable,feed,font,geo,grib,hdf,html,image,isatab,jdbc,jpeg,mail,mat,mbox,microsoft,mp3,mp4,ner,netcdf,ocr,odf,opendocument,pdf,pkg,prt,rtf,txt,wordperfect}

# This test require network
rm %{pkg_name}-core/src/test/java/org/apache/tika/mime/MimeDetectionTest.java \
 %{pkg_name}-core/src/test/java/org/apache/tika/detect/MimeDetectionWithNNTest.java
# These test fails for unavailable deps: com.googlecode.mp4parser:isoparser and org.gagravarr:vorbis-java-tika
rm -r %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/mail/RFC822ParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/mbox/MboxParserTest.java
rm -r %{pkg_name}-parsers/src/test/java/org/apache/tika/detect/TestContainerAwareDetector.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/AutoDetectParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/asm/ClassParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/Bzip2ParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/GzipParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/TarParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/ZipParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/ZlibParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/Seven7ParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/CompressParserTest.java
rm -r %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/image/ImageMetadataExtractorTest.java
# Fails for unavailable test resources
rm -r %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/microsoft/ProjectParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/mp3/Mp3ParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/mime/TestMimeTypes.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/iwork/IWorkParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pkg/ArParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/executable/ExecutableParserTest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/ibooks/iBooksParserTest.java \
 %{pkg_name}-app/src/test/java/org/apache/tika/cli/TikaCLITest.java \
 %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/pdf/PDFParserTest.java

# Fix build against lucene 6.3+
%if 0%{?fedora} >= 29
sed -i -e 's/\(import org.apache\.lucene\.analysis.\)util\.FilteringTokenFilter/\1FilteringTokenFilter/' \
  tika-eval/src/main/java/org/apache/tika/eval/tokens/*FilterFactory.java
%endif

# ComparisonFailure: Date/Time Original for when the photo was taken, unspecified time zone expected:<2009-08-11T[09]:09:45> but was:<2009-08-11T[11]:09:45>
rm -r %{pkg_name}-parsers/src/test/java/org/apache/tika/parser/jpeg/JpegParserTest.java
# Fail on ARM builder TestTimedOutException: test timed out after 30000 milliseconds
rm -r %{pkg_name}-batch/src/test/java/org/apache/tika/batch/fs/BatchDriverTest.java
%{?scl:EOFSCL}

%build
%{?scl:scl enable %{scl_maven} %{scl} - << "EOFSCL"}
set -e -x
# skip tests for now because there are test failures:
# Tests which use cglib fail because of incompatibility with asm4
# Test fails for unavailable build deps: com.googlecode.mp4parser:isoparser
# Error occurred during initialization of VM
# Could not reserve enough space for 2097152KB object heap
%mvn_build -sf -- -Dproject.build.sourceEncoding=UTF-8
%{?scl:EOFSCL}

%install
%{?scl:scl enable %{scl_maven} %{scl} - << "EOFSCL"}
set -e -x
%mvn_install

%if %{without tika_app}
%jpackage_script org.apache.tika.cli.TikaCLI "" "" %{pkg_name}:opennlp:jwnl:jackcess-encrypt:jackcess:google-gson:commons-io:commons-logging:log4j12-1.2.17:metadata-extractor2-2:juniversalchardet:apache-commons-codec:boilerpipe:thredds:bea-stax-api:commons-compress:felix/org.apache.felix.scr.annotations:apache-mime4j/core:apache-mime4j/dom:pdfbox:poi/poi:poi/poi-scratchpad:poi/poi-ooxml:bcmail:bcprov:tagsoup:objectweb-asm/asm-all:rome:fontbox:vorbis-java:dom4j:xmlbeans:poi/poi-ooxml-schemas:xmpcore:slf4j/api:slf4j/log4j12:jdom:jdom2 %{pkg_name}-app true
%endif
%{?scl:EOFSCL}

%files -f .mfiles-%{pkg_name}-core
%doc CHANGES.txt HEADER.txt KEYS README.md
%license LICENSE.txt NOTICE.txt

%if %{without tika_parsers}
%if %{without tika_app}

%files app -f .mfiles-%{pkg_name}-app
%{_bindir}/%{pkg_name}-app
%endif

%files batch -f .mfiles-%{pkg_name}-batch

%files java7 -f .mfiles-%{pkg_name}-java7

%files parsers -f .mfiles-%{pkg_name}-parsers
%endif

%files parent -f .mfiles-%{pkg_name}-parent
%license LICENSE.txt NOTICE.txt

%files pom -f .mfiles-%{pkg_name}
%license LICENSE.txt NOTICE.txt

%files serialization -f .mfiles-%{pkg_name}-serialization

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt NOTICE.txt

%changelog
* Mon Jun 11 2018 Mat Booth <mat.booth@redhat.com> - 1.17-1.2
- Don't ship parsers we can't build or not interested in

* Thu Jun 07 2018 Mat Booth <mat.booth@redhat.com> - 1.17-1.1
- Auto SCL-ise package for rh-eclipse48 collection

* Thu Apr 19 2018 Mat Booth <mat.booth@redhat.com> - 1.17-1
- Update to latest upstream release

* Thu Apr 19 2018 Mat Booth <mat.booth@redhat.com> - 1.12-6
- Drop uneeded dep on CXF

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.12-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.12-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.12-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Sep 28 2016 gil cattaneo <puntogil@libero.it> 1.12-2
- enable translate sub module

* Tue Apr 12 2016 gil cattaneo <puntogil@libero.it> 1.12-1
- update to 1.12

* Fri Apr 08 2016 gil cattaneo <puntogil@libero.it> 1.11-3
- rebuilt with apache-poi 3.14 and bcprov 1.54

* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.11-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Oct 30 2015 gil cattaneo <puntogil@libero.it> 1.11-1
- update to 1.11

* Tue Oct 06 2015 gil cattaneo <puntogil@libero.it> 1.9-2
- add opennlp support

* Wed Sep 02 2015 gil cattaneo <puntogil@libero.it> 1.9-1
- update to 1.9

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Apr 22 2015 gil cattaneo <puntogil@libero.it> 1.5-5
- rebuilt with new metadata-extractor2.8.1

* Mon Apr 20 2015 gil cattaneo <puntogil@libero.it> 1.5-4
- rebuilt with new metadata-extractor2.7.2

* Fri Mar 06 2015 gil cattaneo <puntogil@libero.it> 1.5-3
- rebuilt with new jhighlight

* Mon Feb 16 2015 gil cattaneo <puntogil@libero.it> 1.5-2
- introduce license macro

* Tue Jul 01 2014 gil cattaneo <puntogil@libero.it> 1.5-1
- update to 1.5

* Wed Jun 11 2014 Fabrice Bellet <fabrice@bellet.info> 1.4-7
- enable app module, RHBZ#1109072

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 07 2014 Michal Srb <msrb@redhat.com> - 1.4-5
- Port to bouncycastle 1.50

* Tue Nov 19 2013 gil cattaneo <puntogil@libero.it> 1.4-4
- enable vorbis-java-tika support

* Wed Oct 23 2013 Mikolaj Izdebski <mizdebsk@redhat.com> - 1.4-3
- Rebuild to regenerate broken POMs
- Related: rhbz#1021484

* Mon Oct 21 2013 gil cattaneo <puntogil@libero.it> 1.4-2
- enable parsers and xpm modules

* Thu Aug 29 2013 gil cattaneo <puntogil@libero.it> 1.4-1
- update to 1.4

* Tue Oct 23 2012 gil cattaneo <puntogil@libero.it> 1.2-1
- initial rpm
